## (a)To find ols estimator of beta and standard deviation of beta for t dist


a<-1.5                   ## alpha
b<- 7.5                  ## beta 
n<-15                                

e<-rt(n,5)             ## random sample from given dist.

X<-runif(15,min=0,max=20)

df<-data.frame(X,Y=a+b*X+e*X)
fm<-lm(Y~1+X,data=df)
yhat<-fitted(fm)
ehat<-residuals(fm)


sd(
   replicate(1000,
             coef(lm(Y ~ 1 + X, data = data.frame(X, Y = a + b * X + rt(n,5)*X)))[2])
   )



## Standard deviation of beta using Bootstrap residual

bootstrap<-function(ehat, yhat, X)
{
    ## bootstrap sample   
    e1 <- sample(ehat, length(ehat), replace =TRUE)
    Y1 <- yhat + e1
    fm1 <- lm(Y1~1+X)
    b1 <- coef(fm1)[2]
    return(b1)
} 

B <- replicate(200, bootstrap(e, yhat, X))              

sd(B)


##(b)Standard deviation of beta using jackknife technique

jacknifebeta<- vector()

for(i in 1:n)
 {
   subdf<-df[-i,]                             ## delete 1 obs.
   fm2<-  lm(Y~1+X,data=subdf)                ## fitted regression  
   B2<-coef(fm2)[2]                           ## value of beta
   jacknifebeta[i]<-B2
  
}
jackybetavar<-((n-1)^2/n)*var(jacknifebeta)  
sqrt(jackybetavar)


##(c) Standard deviation of beta using paired bootstrap 

q=matrix(ncol=2,nrow=n)
q[,1]=df$X
q[,2]=df$Y
Beta=vector()

pairedsample <- function(df)
{
    
    i <- sample(seq(length.out = nrow(df)), replace = TRUE)
    df1 <- df[i, ]
    fm <- lm(Y ~ 1 + X, df1)
    beta<-coef(fm)[2]
    return(beta)
}

Beta <- replicate(200, pairedsample(df))
sd(Beta)



  
